# Images in bar chart

Current plugin lets you add an custom image to each bar in bar charts.
Can be useful to visualize leaderboard, for instance, making it more attractive when using
people's avatars.

## Steps to configure the plugin

To make plugin you need to make next steps:
1. Make sure your elasticube table contains the column with all required images for every row;
(it is okay if some rows won't have image - if this rows will be shown in the charts, image just won't render)
2. Create new custom field in elasticube, using two columns 1 - the column you initially wanted to use as
a category, 2 - the image url table. Combine this 2 columns using next SQL expression:
``IfString([photolink] != NULL, [name] + '---' + [photolink], [name] + '---')`` where ``[photolink]`` is
your column containing image urls, and ``[name]`` - column you want to use as category as a result you should have column,
which has something similar to line below in it's rows:
``Name Surname---http://www.example.com/example.png``
3. Go to Sisense and create bar chart with the field generated on step 2 as category, and random number of values
4. Select on of the values in the panel you want attach image to, open it's menu and click ``Use For Image`` menu item

Now you will see images appearing in the end of bar items for which data-items in elasticube image url was specified.

## Notes regarding images usage
- Plugin supports .png .jpeg and .gif file extensions. 
- Although https links could be used as image sources, it may cause inappropriate behaviour, thus 
usage of http links is recommended
- local images can be used. To make it work place images under ``/images`` folder under the plugin folder
 and use next links in elasticube: ``/plugins/imagesInBarChart/images/<imageNmae>``. The folder could be different
 but in this case links in elasticube should be added appropriately
 
## Notes regarding CSV export
As widget is using newly generated field as a category, when exporting to csv you will see generated field which contains
Name and link in each row instead of just Name. If csv export is critical follow steps below to change field with name and link 
to name field.

1. Open widget edit script view.
2. Enter next code in opened editor:
``prism.swapFields(widget, {fieldToBeChanged: "[Sheet1.NamePic]", fieldToBeUsed: "[Sheet1.name]"})``
where [Sheet1.NamePic] - is the name of field with names and links, and [Sheet1.name] - is a field with names only

## Limitations with exporting to image
Export to image from widget view is not working due to limitations in third party library used to export html to png.
Dashboard export to pdf and png is working fine.