// this is part that adds "use for image" point to panel value's menu
// for more info on how to use it see documentation or README
prism.run([
	function() {

		let setOption = function() {
			this.currentValue.useImage = !this.checked; // toggle useImage for current value in widget's panel
			this.widget.redraw();
		};

		let onBeforeMenu = function (scope, args) {

			if (args.settings.item != undefined &&
				args.settings.item.$$panel != undefined &&
				args.settings.item.$$panel.name == 'values' &&
				args.settings.item.$$panel.$$widget.type == 'chart/bar') {

				let widget = args.settings.item.$$panel.$$widget,
					currentValue = widget.metadata.panel("values").items[args.settings.scope.$parent.$index],
					menuItems = args.settings.items,
					useImage = currentValue.useImage, // read previous value, would be undefined by default
					baseMenuItem = {
						useImage: useImage,
						currentValue: currentValue, // we need to pass current value to make values preserve after setOption is called
						widget: widget,
						size: 'xl',
						type: 'check'
					},
					menuItem = {};

				menuItems.push({type: "separator"});


				menuItem = Object.assign({
					caption: "Use for Image",
					checked: useImage === true,
					execute: setOption
				}, baseMenuItem);

				menuItems.push(menuItem);


			}
		};

		prism.on('beforemenu', onBeforeMenu);
	}
]);
